#line 1 "C:/Documents and Settings/WinXP/Desktop/Gsm_Logger_45K22/Gsm_Logger.c"









sbit Mmc_Chip_Select at LATD3_bit;
sbit Mmc_Chip_Select_Direction at TRISD3_bit;


sbit Soft_I2C_Scl at RD4_bit;
sbit Soft_I2C_Sda at RD5_bit;
sbit Soft_I2C_Scl_Direction at TRISD4_bit;
sbit Soft_I2C_Sda_Direction at TRISD5_bit;


sbit LCD_RS at RA2_bit;
sbit LCD_EN at RA3_bit;
sbit LCD_D4 at RA4_bit;
sbit LCD_D5 at RA5_bit;
sbit LCD_D6 at RE0_bit;
sbit LCD_D7 at RE1_bit;
sbit LCD_RS_Direction at TRISA2_bit;
sbit LCD_EN_Direction at TRISA3_bit;
sbit LCD_D4_Direction at TRISA4_bit;
sbit LCD_D5_Direction at TRISA5_bit;
sbit LCD_D6_Direction at TRISE0_bit;
sbit LCD_D7_Direction at TRISE1_bit;
#line 48 "C:/Documents and Settings/WinXP/Desktop/Gsm_Logger_45K22/Gsm_Logger.c"
int selection = 0;
const char character1[] = {7,15,31,31,21,27,21,31};

char filename[14] = "DATALOG1.TXT";
char rtrn [] = "\r\n";
short flag = 0;
short rtcint = 0;
char ch;
char buffer[50];
unsigned short index = 0;
char numero_consentito[] = "+393402659130";
unsigned int adc_value;
char level[7] = "00.00";
long temp;


char secondi = 0;
char minuti = 0;
char ore = 0;
char giorno = 1;
char giorno_settimana;
char mese = 1;
char anno = 1;
char secolo;
char sampling = 15;
char time [9];
char date [11];
char bufferLcd [3];


char atc0[] = "AT";
char atc1[] = "ATE0";
char atc2[] = "ATH";
char atc3[] = "AT+CRC=1";
char atc4[] = "AT+CLIP=1";
char atc5[] = "AT+CMGF=1";
char atc6[] = "AT+CMGS=+393406642911";
char atc7[] = "AT+CMGD=1";


void initSettings();
void initSdCard();
void uartGo();
void gsmConfig ();
void sendAtc (char *s);
void wait ();
void pause ();
void adcResult ();
void fixedLcd ();
void CharADC(char pos_row, char pos_char);
void resetWdt();
void rtcWrite(char address, char reg, char variabile);
void rtcRead();
void rtcConversion();
void rtcDisplay();
char rtcSet(char variabile, char max, char max_value, char min, char address, char reg);
void Character_SD(char pos_row, char pos_char);
void rtcIntWrite ();
void sampleLcd();
void writeSdCard();
void M_Create_New_File();


void Interrupt() iv 0x0008 ics ICS_OFF
{
if (INTCON.RBIF)
 {
 if (! PORTB.RB5)
 {
  PORTD.RD1  = !  PORTD.RD1 ;
 flag = 1;
 }

 if (! PORTB.RB4)
 {
  PORTD.RD2  = !  PORTD.RD2 ;
 rtcint = 1;
 }

 INTCON.RBIF = 0;
 }
}

void main()
{
initSettings();
fixedLcd();
initSdCard();
Lcd_Out (4, 7, "--.--");
gsmConfig();
rtcIntWrite();

while (1)
 {
 resetWdt();
 adcResult();
 uartGo();
 rtcRead();
 rtcConversion();
 rtcDisplay();
 writeSdCard();
 sampleLcd();
 if (!  PORTC.RC0 )
 {
 Delay_ms ( 200 );
 selection++;
 if (selection >= 7) selection = 0;
 }

 switch (selection)
 {
 case 0:
 Lcd_Out (1, 11, "      ");
 Lcd_Out (2, 9, "        ");
 break;

 case 1:
 rtcSet(giorno, 32, 31, 1,  0xA2 ,  0x05 );
 Lcd_Out (1, 11, "<--SET");
 break;

 case 2:
 rtcSet (mese, 13, 12, 1,  0xA2 ,  0x07 );
 Lcd_Out (1, 11, "<--SET");
 break;

 case 3:
 rtcSet (anno, 98, 97, 0,  0xA2 ,  0x08 );
 Lcd_Out (1, 11, "<--SET");
 break;

 case 4:
 rtcSet (ore, 24, 23, 0,  0xA2 ,  0x04 );
 Lcd_Out (2, 9, "<----SET");
 Lcd_Out (1, 11, "      ");
 break;

 case 5:
 rtcSet (minuti, 60, 59, 0,  0xA2 ,  0x03 );
 Lcd_Out (2, 9, "<----SET");
 break;

 case 6:
 rtcSet (secondi, 60, 59, 0,  0xA2 ,  0x02 );
 Lcd_Out (2, 9, "<----SET");
 break;
 }
 }
}


void resetWdt ()
{
asm CLRWDT;
}


void adcResult ()
{
adc_value = ADC_Read (0);
Delay_ms (300);
temp = (long) adc_value * 5000;
temp = temp / 1023;

if (temp < 985) temp = 985;
else if (temp > 5000) temp = 5000;






temp = (temp - 985) * 2.5;

level [0] = temp / 10000 + 48;
level [1] = (temp/1000)%10+48;
level [3] = (temp/100)%10+48;
level [4] = (temp/10)%10+48;

Lcd_Out (4, -3, "Level--->");

Lcd_Chr (4, 12, 'm');
Lcd_Out (4, 7, level);
}


void uartGo ()
{
if (flag)
 {
 while (1)
 {
 while (! UART1_Data_Ready()) ;
 if (UART1_Read() == '"') break;
 }


 index = 0;

 while (1)
 {
 while (! UART1_Data_Ready()) ;
 ch = UART1_Read();


 if (ch == '"') break;


 buffer[index] = ch;
 index ++ ;
 }
 buffer[index] = '\0';



 Delay_ms(200);
 while (UART1_Data_Ready()) UART1_Read();


 if (strcmp (buffer, numero_consentito) == 0)
 {

 sendAtc (atc2);
 pause ();
 sendAtc (atc6);
 pause ();
 UART1_Write_Text ("Livello vasca ");
 pause ();
 UART1_Write_Text (level);
 pause ();
 UART1_Write (0x1A);
 }

 flag = 0;
 }
}


void rtcRead ()
{
Soft_I2C_Start();
Soft_I2C_Write ( 0xA2 );
Soft_I2C_Write (2);
Soft_I2C_Stop();
Soft_I2C_Start();
Soft_I2C_Write ( 0xA3 );

secondi = Soft_I2C_Read (1);
minuti = Soft_I2C_Read (1);
ore = Soft_I2C_Read (1);
giorno = Soft_I2C_Read (1);
giorno_settimana = Soft_I2C_Read (1);
mese = Soft_I2C_Read (1);
anno = Soft_I2C_Read (1);
Soft_I2C_Stop();
}


void rtcConversion ()
{
secondi = Bcd2Dec (secondi & 0x7F);
minuti = Bcd2Dec (minuti & 0x7F);
ore = Bcd2Dec (ore & 0x3F);
giorno = Bcd2Dec (giorno & 0x3F);
mese = Bcd2Dec (mese & 0x1F);
anno = Bcd2Dec (anno & 0xFF);
giorno_settimana = (giorno_settimana & 0x07);
secolo = (mese & 0x80);
}


void rtcDisplay ()
{
time [0] = (ore/10)+48;
time [1] = (ore%10)+48;
time [2] = ':';
time [3] = (minuti/10)+48;
time [4] = (minuti%10)+48;
time [5] = ':';
time [6] = (secondi/10)+48;
time [7] = (secondi%10)+48;
time [8] = '\0';
Lcd_Out (2, 1, time);

date [0] = (giorno/10)+48;
date [1] = (giorno%10)+48;
date [2] = '/';
date [3] = (mese/10)+48;
date [4] = (mese%10)+48;
date [5] = '/';
date [6] = '2';
date [7] = (secolo+48);
date [8] = (anno/10)+48;
date [9] = (anno%10)+48;
date [10] = '\0';
Lcd_Out (1, 1, date);
}


void writeSdCard()
{
if (rtcint)
 {
 Mmc_Fat_Assign("DATALOG1.TXT", 0xA0);
 Mmc_Fat_Append();
 Mmc_Fat_Write (date, 11);
 Mmc_Fat_Write (time, 9);
 Mmc_Fat_Write (level, 7);
 Mmc_Fat_Write(rtrn,2);


 Soft_I2C_Start();
 Soft_I2C_Write ( 0xA2 );
 Soft_I2C_Write (0x01);
 Soft_I2C_Write (0x01);
 Soft_I2C_Stop();

 rtcint = 0;
 }
}

void sampleLcd()
{
Lcd_Out (3, -3, "Sample ");
bufferLcd [0] = (sampling/10)+48;
bufferLcd [1] = (sampling%10)+48;
bufferLcd [2] = '\0';
Lcd_Out(3, 4, bufferLcd);
}


char rtcSet (char variabile, char max, char max_value, char min, char address, char reg)
{
if (!  PORTC.RC1 )
 {
 Delay_ms ( 200 );
 if (variabile < max)
 {
 variabile++;
 if (variabile > max_value) variabile = min;
 }
 }

rtcWrite (address, reg, variabile);

return variabile;
}


void rtcWrite (char address, char reg, char variabile)
{
Soft_I2C_Start();
Soft_I2C_Write (address);
Soft_I2C_Write (reg);
Soft_I2C_Write (Dec2Bcd (variabile));
Soft_I2C_Stop();
}


void rtcIntWrite ()
{
Soft_I2C_Start();
Soft_I2C_Write ( 0xA2 );
Soft_I2C_Write (0x01);
Soft_I2C_Write (0x01);
Soft_I2C_Start();
Soft_I2C_Write ( 0xA2 );
Soft_I2C_Write (0x0F);
Soft_I2C_Write (0x0F);
Soft_I2C_Start();
Soft_I2C_Write ( 0xA2 );
Soft_I2C_Write (0x0E);
Soft_I2C_Write (0x83);
Soft_I2C_Stop();
}


void sendAtc(char *s)
{
 while(*s) {
 UART1_Write(*s++);
 }
 UART1_Write('\r');
}


void gsmConfig ()
{
sendAtc (atc0);
pause ();
sendAtc (atc1);
pause ();
sendAtc (atc3);
pause ();
sendAtc (atc4);
pause ();
sendAtc (atc5);
}


void M_Create_New_File()
{
Mmc_Fat_Assign ("DATALOG1.TXT", 0xA0);
}


void fixedLcd ()
{
Lcd_Out (1, 1, "..initializing..");
Lcd_Out (2, 1, "Please Wait  15s");
pause ();

Lcd_Out (2, 14, "14s");
pause ();

Lcd_Out (2, 14, "13s");
pause ();

Lcd_Out (2, 14, "12s");
pause ();

Lcd_Out (2, 14, "11s");
pause ();

Lcd_Out (2, 14, "10s");
pause ();

Lcd_Out (2, 14, "09s");
pause ();

Lcd_Out (2, 1, "08s");
pause ();

Lcd_Out (2, 14, "07s");
pause ();

Lcd_Out (2, 14, "06s");
pause ();

Lcd_Out (2, 14, "05s");
pause ();

Lcd_Out (2, 14, "04s");
pause ();

Lcd_Out (2, 14, "03s");
pause ();

Lcd_Out (2, 14, "02s");
pause ();

Lcd_Out (2, 14, "01s");
pause ();


Lcd_Out (1, 1, ">>>>>>>><<<<<<<<");
Lcd_Out (2, 1, ">    SYSTEM    <");
Lcd_Out (3, -3, ">      ON     <");
Lcd_Out (4, -3, ">>>>>>>><<<<<<<<");
wait ();
Lcd_Cmd (_LCD_CLEAR);
}


void wait ()
{
Delay_ms (2000);
}


void pause ()
{
Delay_ms (1000);
}


void Character_SD(char pos_row, char pos_char)
{
char i;
Lcd_Cmd(64);
for (i = 0; i<=7; i++) Lcd_Chr_CP(character1[i]);
Lcd_Cmd(_LCD_RETURN_HOME);
Lcd_Chr(pos_row, pos_char, 0);
}


void initSdCard()
{

SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);


if (Mmc_Fat_Init() == 0)
 {

 SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);

 M_Create_New_File();
 }


else
 {

 Character_SD (3, 12);
 }
}


void initSettings ()
{
ANSELA = 0b00000001;
ANSELB = 0b00000000;
ANSELC = 0b00000000;
ANSELD = 0b00000000;
ANSELE = 0b00000000;

PORTA = 0;
TRISA = 0b11000011;

PORTB = 0;
TRISB = 0b11111111;

PORTC = 0;
TRISC = 0b10010111;

PORTD = 0;
TRISD = 0b11110001;

PORTE = 0;
TRISE = 0b00001000;


Lcd_Init();
Lcd_Cmd (_LCD_CURSOR_OFF);
Lcd_Cmd (_LCD_CLEAR);
 PORTE.RE2  = 1;


UART1_Init(9600);
Delay_ms (100);


ADC_Init ();


Soft_I2C_Init();


RCON.IPEN = 0;


INTCON.GIE = 1;


INTCON.RBIE = 1;
}
